## ntpsec 1.2.1+dfsg1

=== wscript ===
from __future__ import print_function

from datetime import datetime
import itertools
import os
import shlex
import sys
import time

from waflib import Build
from waflib import Context
from waflib import Scripting
from waflib import Utils
from waflib.Build import (BuildContext, CleanContext, InstallContext,
                          StepContext, ListContext)
from waflib.Context import BOTH
from waflib.Errors import WafError
from waflib.Logs import pprint
from waflib.Tools import waf_unit_test

# Avoid writing .pyc files in wafhelpers/
sys.dont_write_bytecode = True

from wafhelpers.options import options_cmd
from wafhelpers.probes import probe_header, probe_function
from wafhelpers.test import test_write_log, test_print_log


pprint.__doc__ = None

APPNAME = 'ntpsec'

out = "build"

config = {
    "out": out,
    "OPT_STORE": {}
}


def help(ctx):
    "Be helpful, give a usage"
    print('''
Usage: waf <command>
    build       Build the project
    check       Run tests
    configure   Configure the project
    dist        Create a release
    install     Install the project
    loccount    Show SLOC count of the source tree
    uninstall   Uninstall the project

''')


def options(ctx):
    options_cmd(ctx, config)
    ctx.load('asciidoc', tooldir='wafhelpers/')
    ctx.recurse("pylib")


def configure(ctx):
    ctx.load('asciidoc', tooldir='wafhelpers/')

    class oc(Build.BuildContext):
        cmd = 'oc'

        def exec_command(self, cmd, **kw):
            kw['output'] = BOTH
            try:
                err, out = self.cmd_and_log(cmd, **kw)
            except WafError as e:
                self.logger.debug('WafError')
                return e.returncode
            if (len(out) and any(word in out for word
                                 in ['err', 'err:', 'error', 'error:',
                                     'ignored', 'illegal', 'unknown',
                                     'unrecognized', 'warning'])):
                self.logger.debug('noooo %r' % out)
                return 1
            if err:
                self.logger.debug('noooo %r' % err)
                return 1
            return 0

    def msg(str):
        pprint("YELLOW", str)

    def msg_setting(name, val):
        pprint("NORMAL", "  %-30s: " % name, sep="")
        pprint("YELLOW", val)

    srcnode = ctx.srcnode.abspath()
    bldnode = ctx.bldnode.abspath()

    ctx.run_build_cls = 'check'
    ctx.load('waf', tooldir='wafhelpers/')
    ctx.load('waf_unit_test')
    ctx.load('gnu_dirs')

    with open("VERSION", "r") as f:
        ntpsec_release = f.read().split(" ")[0].strip()

    ctx.env.OPT_STORE = config["OPT_STORE"]

    opt_map = {}
    # Wipe out and override flags with those from the commandline
    for flag in ctx.env.OPT_STORE:
        if flag == "--undefine":
            for sym in ctx.env.OPT_STORE[flag]:
                ctx.undefine(sym)
        elif flag == "--define":
            for symval in ctx.env.OPT_STORE[flag]:
                (sym, val) = symval.split("=")
                try:
                    ctx.define(sym, int(val))
                except ValueError:
                    ctx.define(sym, val)
        else:
            opt = flag.replace("--", "").upper()
            opt_map[opt] = ctx.env.OPT_STORE[flag]

    ctx.env['ntpc'] = ctx.options.enable_pylib
    ctx.env['ntpcver'] = '1.1.0'

    msg("--- Configuring host ---")
    ctx.setenv('host', ctx.env.derive())

    ctx.load('compiler_c')
    ctx.start_msg('Checking compiler version')
    ctx.end_msg("%s" % ".".join(ctx.env.CC_VERSION))

    # Some distros do not have /sbin in the PATH for non-root users.  We honor
    # the real PATH first, but append the sbin directories.
    ctx.find_program(
        "ldconfig", var="BIN_LDCONFIG", mandatory=False,
        path_list=(os.environ.get('PATH','').split(os.pathsep) +
            ["/sbin", "/usr/sbin", "/usr/local/sbin"]))

    # Ensure m4 is present, or bison will fail with SIGPIPE
    ctx.find_program('m4')
    ctx.load('bison')

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.enable_rtems_trace:
        ctx.find_program("rtems-tld", var="BIN_RTEMS_TLD",
                         path_list=[ctx.options.rtems_trace_path,
                                    '${BINDIR}'])
        ctx.env.RTEMS_TEST_ENABLE = True
        ctx.env.RTEMS_TEST_FLAGS = [
            "-C", "%s/devel/trace/ntpsec-trace.ini" % srcnode,
            "-W", "%s/ntpsec-wrapper" % bldnode,
            "-P", "%s/devel/trace/" % srcnode,
            "-f", "-I%s" % bldnode,
            "-f", "-I%s/include/" % srcnode,
        ]

    # Not needed to build.  Used by utility scripts.
    ctx.find_program("awk", var="BIN_AWK", mandatory=False)
    ctx.find_program("sh", var="BIN_SH", mandatory=False)

    ctx.check_cfg(
        package='systemd', variables=['systemdsystemunitdir'],
        uselib_store='SYSTEMD', mandatory=False,
        msg="Checking for systemd")
    if ctx.env.SYSTEMD_systemdsystemunitdir:
        ctx.start_msg("systemd unit directory:")
        ctx.end_msg(ctx.env.SYSTEMD_systemdsystemunitdir)

    ctx.env.BIN_GIT = False
    if os.path.exists(".git"):
        ctx.find_program("git", var="BIN_GIT", mandatory=False)

    build_desc = ctx.options.build_desc.strip()
    if build_desc:
        build_desc = ' ' + build_desc
    if ctx.env.BIN_GIT:
        cmd = ctx.env.BIN_GIT + shlex.split("describe --dirty")
        git_short_hash = ctx.cmd_and_log(cmd).strip()
        git_short_hash = '-'.join(git_short_hash.split('-')[1:])

        ctx.env.NTPSEC_VERSION = "%s+" % ntpsec_release
        ctx.env.NTPSEC_VERSION_EXTENDED = ("%s+%s%s" %
                                           (ntpsec_release,
                                            git_short_hash,
                                            build_desc))
    else:
        ctx.env.NTPSEC_VERSION = "%s" % ntpsec_release
        ctx.env.NTPSEC_VERSION_EXTENDED = ("%s%s" % (ntpsec_release,
                                                      build_desc))
    ctx.define("NTPSEC_VERSION", ctx.env.NTPSEC_VERSION)
    ctx.define("NTPSEC_VERSION_EXTENDED", ctx.env.NTPSEC_VERSION_EXTENDED)

    # We require some things that C99 doesn't enable, like pthreads.
    # These flags get propagated to both the host and main parts of the build.
    #
    # _POSIX_C_SOURCE
    #      If ==1, like _POSIX_SOURCE;
    #      if >=2 add IEEE Std 1003.2;
    #      if >=199309L, add IEEE Std 1003.1b-1993;
    #      if >=199506L, add IEEE Std 1003.1c-1995;
    #      if >=200112L, all of IEEE 1003.1-2004
    #      if >=200809L, all of IEEE 1003.1-2008
    #
    # FIXME: We'd like this to be -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=700
    # rather than -D_GNU_SOURCE, but that runs into problems in two places:
    # (1) The ISC net handling stuff, where struct in6_addr’ loses a member
    # named s6_addr32 that the macros need, and (2) three BSD functions
    # related to chroot jailing in the sandbox code.
    #
    # Note that _POSIX_C_SOURCE >= 199506L and _GNU_SOURCE both turn on
    # _POSIX_PTHREAD_SEMANTICS and _REENTRANT
    #
    ctx.env.CFLAGS = ["-std=c99", "-D_GNU_SOURCE"] + ctx.env.CFLAGS

    msg("--- Configuring main ---")
    ctx.setenv("main", ctx.env.derive())

    from wafhelpers.check_sizeof import check_sizeof

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.cross_compiler:
        ctx.env.ENABLE_CROSS = True

        ctx.start_msg("Using Cross compiler CC:")
#           ctx.get_cc_version(ctx.env.CC, gcc=True)
        ctx.end_msg(ctx.options.cross_compiler)

        ctx.env.CC = shlex.split(ctx.options.cross_compiler)
        ctx.env.LINK_CC = shlex.split(ctx.options.cross_compiler)

        if ctx.env["CROSS-CFLAGS"]:
            # Lexically split each part of the CFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-CFLAGS"]]
            ctx.env.CFLAGS = list(itertools.chain.from_iterable(iter))

        if ctx.env["CROSS-LDFLAGS"]:
            # Lexically split each part of the LDFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-LDFLAGS"]]
            ctx.env.LDFLAGS = list(itertools.chain.from_iterable(iter))

    if ctx.options.list:
        from wafhelpers.refclock import refclock_map
        print("ID    Description")
        print("~~    ~~~~~~~~~~~")
        for id in refclock_map:
            print("%-5s %s" % (id, refclock_map[id]["descr"]))

        return

    # These are required by various refclocks
    # needs to be tested before CFLAGS are set
    if ctx.check_endianness() == "big":
        ctx.define("WORDS_BIGENDIAN", 1)

    if ctx.options.enable_leap_testing:
        ctx.define("ENABLE_LEAP_TESTING", 1,
                   comment="Enable leap seconds on other than 1st of month.")

    # check for some libs first.  some options, like stack protector,
    # may depend on some libs, like -lssp
    ctx.check_cc(lib="m", comment="Math library")
    ctx.check_cc(lib="rt", mandatory=False, comment="realtime library")
    ctx.check_cc(lib="pthread", mandatory=False, comment="threads library")
    ctx.check_cc(lib="execinfo", mandatory=False,
                 comment="BSD backtrace library")
    ret = ctx.check_cc(lib="bsd", mandatory=False,
                       comment="BSD compatibility library")
    if ret:
        ctx.env.LDFLAGS += ["-lbsd"]

    # -lssp and -lssp_nonshared may be needed by older gcc to
    # support "-fstack-protector-all"
    ret = ctx.check_cc(lib="ssp", mandatory=False,
                       comment="libssp")
    if ret:
        ctx.env.LDFLAGS += ["-lssp"]

    ret = ctx.check_cc(lib="ssp_nonshared", mandatory=False,
                       comment="libssp_nonshared")
    if ret:
        ctx.env.LDFLAGS += ["-lssp_nonshared"]

    cc_test_flags = [
        ('f_stack_protector_all', '-fstack-protector-all'),
        ('PIC', '-fPIC'),
        ('PIE', '-pie -fPIE'),
        # this quiets most of macOS warnings on -fpie
        ('unused', '-Qunused-arguments'),
        # This is a useless warning on any architecture with a barrel
        # shifter, which includes Intel and ARM and basically
        # everything nowadays. Even so, we'd enable it out of
        # perfectionism, but the GCC directives that ought to be
        # useful for forcing structure alignment in order to suppress
        # it locally don't seem to be working quite right.
        # ('w_cast_align', "-Wcast-align"),
        ('w_cast_qual', "-Wcast-qual"),
        ('w_disabled_optimization', "-Wdisabled-optimization"),
        ('w_float_equal', "-Wfloat-equal"),
        ('w_format', '-Wformat'),
        ('w_format_security', '-Wformat-security'),
        # fails on OpenBSD 6
        ('w_format_signedness', '-Wformat-signedness'),
        ('w_implicit_function_declaration', "-Wimplicit-function-declaration"),
        ('w_init_self', '-Winit-self'),
        ('w_invalid_pch', '-Winvalid-pch'),
        ('w_missing_declarations', '-Wmissing-declarations'),
        ('w_multichar', '-Wmultichar'),
        ('w_packed', '-Wpacked'),
        ('w_pointer_arith', '-Wpointer-arith'),
        ('w_shadow', '-Wshadow'),
        # fails on clang
        ('w_suggest_attribute_noreturn', "-Wsuggest-attribute=noreturn"),
        ('w_write_strings', '-Wwrite-strings'),
        ]

    # Check which linker flags are supported
    ld_hardening_flags = [
        ("z_now", "-Wl,-z,now"),     # no deferred symbol resolution
    ]

    # we prepend our options to CFLAGS, this allows user provided
    # CFLAGS to override our computed CFLAGS
    if ctx.options.enable_debug_gdb:
        ctx.env.CFLAGS = ["-g"] + ctx.env.CFLAGS
        ctx.define("USEBACKTRACE", "1", quote=False)
    else:
        # not gdb debugging
        cc_test_flags += [
            ('LTO', '-flto'),                   # link time optimization
            ]
        ld_hardening_flags += [

=== libaes_siv/wscript ===
def build(ctx):
    ctx(
        target='aes_siv',
        features='c cstlib',
        includes=[ctx.bldnode.parent.abspath()],
        source='aes_siv.c',
        use='CRYPTO',
        cflags=['-Wno-shadow',
                # '-Wall', '-Wextra', '-Wstrict-prototypes',  # default
                '-Wconversion',
                '-O3',
                '-fomit-frame-pointer',
                '-funroll-loops',
                '-ftree-vectorize',
                '-Wno-inline',  # gcc 10 gives inline warnings?
                ],
    )

=== debian/changelog ===
ntpsec (1.2.1+dfsg1-4) unstable; urgency=high

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Richard Laager ]
  * Remove direct libssl1.1 Depends (Closes: 1006627)

 -- Richard Laager <rlaager@debian.org>  Mon, 28 Feb 2022 18:13:12 -0600

ntpsec (1.2.1+dfsg1-3) unstable; urgency=high

  * Mention NTS in the package description (Closes: 1004010)
  * Backport some changes:
    - Some startup logging fixes
    - Some seccomp fixes for newer glibc / other architectures
    - OpenSSL 3.0 support (Closes: 1005716)

 -- Richard Laager <rlaager@debian.org>  Tue, 15 Feb 2022 20:12:55 -0600

ntpsec (1.2.1+dfsg1-2) unstable; urgency=medium

  * Fix ntpq man page formatting (Closes: 998072)

 -- Richard Laager <rlaager@debian.org>  Fri, 29 Oct 2021 18:54:28 -0500

ntpsec (1.2.1+dfsg1-1) unstable; urgency=medium

  * Fix ntpdate -d.
    Thanks to Bernhard <rep.dot.nop@gmail.com> (Closes: 994819)
  * New upstream version:
    - Update the SHM gpsd documentation
    - ntpdig: continue instead of exit on IPv6 when there is none. solves #680
    - ntpq: solve #689 - 'ntpq -c raw -c readvar' crashes ...
    - ntpq: solve #690 - ntpq does not print associd when 0 ...
    - ntpdig: Fix steplimit option.
    - Improve ntpdate script.
    - ntpdig: Try to handle gaierror better ...
    - Fix parsing of commandline parameter 'P'
    - ntp.util: Shorten ntpq/ntpmon peers common output generation.
    - ntpq, ntpmon: Add dextral peers mode ...
    - ntpq: -c rv should return associd only when variable(s) not passed.
    - Don't generate # into ASCIIfied keys.
  * Stop using removed --build-epoch
  * Update Standards-Version to 4.6.0 (no changes)

 -- Richard Laager <rlaager@debian.org>  Sat, 25 Sep 2021 18:43:40 -0500

=== debian/control ===
Source: ntpsec
Section: net
Priority: optional
Maintainer: Richard Laager <rlaager@debian.org>
Build-Depends: asciidoctor,
               bison,
               debhelper-compat (= 13),
               dh-apache2,
               dh-apparmor,
               dh-python,
               docbook-xsl,
               libbsd-dev,
               libcap2-dev [linux-any],
               libssl-dev,
               netbase,
               pkg-config,
               pps-tools [linux-any],
               python3,
               python3-dev,
               python3-gps,
               systemd,
               xsltproc,
               xz-utils,
Build-Conflicts: libavahi-compat-libdnssd-dev,
                 libwww-dev,
                 libwww-ssl-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/ntpsec
Vcs-Git: https://salsa.debian.org/debian/ntpsec.git
Homepage: https://www.ntpsec.org

Package: ntpsec
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         lsb-base,
         netbase,
         python3,
         python3-ntp (= ${binary:Version}),
         tzdata,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: systemd | cron | cron-daemon,
Suggests: apparmor,
          certbot,
          ntpsec-doc,
          ntpsec-ntpviz,
Conflicts: ntp,
           ntpdate,
           time-daemon,
Provides: time-daemon,
Replaces: ntp,
          time-daemon,
Description: Network Time Protocol daemon and utility programs
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the NTP daemon and utility programs.  An NTP
 daemon needs to be running on each host that is to have its clock
 accuracy controlled by NTP.  The same NTP daemon is also used to
 provide NTP service to other hosts.
 .
 This is the NTPsec version of NTP.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 NTPsec supports Network Time Security (NTS) which provides
 cryptographically authenticated time.
 .
 For more information about the NTP protocol and NTP server
 configuration and operation, install the package "ntpsec-doc".

Package: ntpsec-ntpdate
Architecture: any
Depends: netbase,
         python3,
         python3-ntp (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Conflicts: ntpdate,
Replaces: ntpdate,
Description: client for setting system time from NTP servers
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdate is a simple NTP client that sets a system's clock to match
 the time obtained by communicating with one or more NTP servers.  It
 is not sufficient, however, for maintaining an accurate clock in the
 long run.  ntpdate by itself is useful for occasionally setting the
 time on machines that do not have full-time network access, such as
 laptops.
 .
 This is the NTPsec version of ntpdate.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 .
 If the full NTP daemon from the package "ntpsec" is installed, then
 ntpsec-ntpdate is not necessary.

Package: ntpsec-ntpviz
Architecture: any
Depends: adduser,
         fonts-liberation,
         gnuplot-nox | gnuplot,
         python3,
         python3-ntp (= ${binary:Version}),
         systemd | cron | cron-daemon,
         ${misc:Depends},
Recommends: ntpsec,
            systemd | python3-psutil,
            ${misc:Recommends},
Suggests: python3-gps,
Description: NTP statistics graphing utility
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpviz analyzes NTP log files and generates statistical plots from
 them.  The output is in the form of HTML with images.  If Apache is
 installed, it will be served at: /ntpviz
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: ntpsec-doc
Architecture: all
Depends: ${misc:Depends},
Section: doc
Multi-Arch: foreign
Description: Network Time Protocol documentation
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains HTML documentation for the ntpsec packages (ntpsec,
 ntpsec-ntpdate).
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: python3-ntp
Architecture: any
Depends: python3,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Provides: ${python3:Provides},
Section: python
Description: Python 3 NTP Helper Classes
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the Python "ntp" module, which contains helper
 classes for NTP utilities written in Python.
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

=== debian/watch ===
version=4
opts="\
    compression=xz,repack,\
    dversionmangle=s/\+dfsg\d*$//,\
    oversionmangle=s/$/+dfsg1/,\
    pgpsigurlmangle=s/$/.asc/" \
  https://ftp.ntpsec.org/pub/releases/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ \
  debian debian/repack-waf

## ntpsec 1.2.2%2Bdfsg1

=== debian/changelog ===
ntpsec (1.2.2+dfsg1-1.0nosystemd1) nosystemd; urgency=medium

  * No systemd/elogind
  * include runit acripts
  * include runit in post/pre install scripts 

 -- anticapitalista <antix@operamail.com>  Wed, 01 Feb 2023 18:06:12 +0200

ntpsec (1.2.2+dfsg1-1) unstable; urgency=medium

  * New upstream version
    - Restore/cleanup NTPv1 support
    - NTS supports partial wildcards, for example *.example.com
    - Work on documentation, ntpdate, ntpheat, ntploggpg, ntpq’s sysstats,
      ntpviz, and seccomp.
    - NTP auth no longer breaks on NULs.
    - The NTS server now saves 10 days worth of cookie keys. This will allow
      clients that only poll once a day to use NTS without using NTS-KE to
      keep cookies up to date.
    - rawstats now logs dropped packets and their BOGON code
    - Add 4 or 6 to DNS/NTS RefID tags to indicate that the DNS or NTS-KE has
      succeeded but NTP has not worked yet.
    - Fix hash validation in ntpleapfetch again
  * Update Standards-Version to 4.6.2 (no changes)
  * Write pidfile in parent (Closes: 1023023)

 -- Richard Laager <rlaager@debian.org>  Mon, 16 Jan 2023 21:50:45 -0600

ntpsec (1.2.1+dfsg1-8) unstable; urgency=medium

  * Fix ntpdate-debian error on ntp.conf (Closes: 1020865)
  * ntpdig: Only show socket error messages in debug (Closes: 971523)
  * ntpdig: Continue on errors in non-concurrent mode
  * ntpdate: Disable JSON (Closes: 1020865)

 -- Richard Laager <rlaager@debian.org>  Tue, 18 Oct 2022 01:15:33 -0500

ntpsec (1.2.1+dfsg1-7) unstable; urgency=medium

  * watch: Use FTP
  * watch: Fix syntax to help lintian
  * ntplogtemp: Fix printing blank line on exit

 -- Richard Laager <rlaager@debian.org>  Tue, 10 May 2022 21:30:41 -0500

ntpsec (1.2.1+dfsg1-6) unstable; urgency=low

  * Add a NEWS.Debian bit with transitional details for those coming from
    the ntp package.  Unfortunately, apt-listchanges will not show this
    to those upgrading from ntp due to source vs binary version number
    differences relating to the transition.

 -- Richard Laager <rlaager@debian.org>  Sun, 03 Apr 2022 15:45:01 -0500

ntpsec (1.2.1+dfsg1-5) experimental; urgency=medium

  * Add ntpd.service alias
  * Add ntp transitional packages (Closes: 1003966)

 -- Richard Laager <rlaager@debian.org>  Tue, 08 Mar 2022 00:37:42 -0600

=== debian/control ===
--- 
+++ 
@@ -18,13 +18,12 @@
                python3,
                python3-dev,
                python3-gps,
-               systemd,
                xsltproc,
                xz-utils,
 Build-Conflicts: libavahi-compat-libdnssd-dev,
                  libwww-dev,
                  libwww-ssl-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/ntpsec
 Vcs-Git: https://salsa.debian.org/debian/ntpsec.git
@@ -46,11 +45,10 @@
           certbot,
           ntpsec-doc,
           ntpsec-ntpviz,
-Conflicts: ntp,
-           ntpdate,
-           time-daemon,
+Breaks: ntp (<< 1:4.2.8p15+dfsg-2~),
+Conflicts: time-daemon,
 Provides: time-daemon,
-Replaces: ntp,
+Replaces: ntp (<< 1:4.2.8p15+dfsg-2~),
           time-daemon,
 Description: Network Time Protocol daemon and utility programs
  NTP, the Network Time Protocol, is used to keep computer clocks
@@ -74,12 +72,11 @@
 Package: ntpsec-ntpdate
 Architecture: any
 Depends: netbase,
-         python3,
-         python3-ntp (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends},
-Conflicts: ntpdate,
-Replaces: ntpdate,
+         ntpsec-ntpdig (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends},
+Breaks: ntpdate (<< 1:4.2.8p15+dfsg-2~),
+Replaces: ntpdate (<< 1:4.2.8p15+dfsg-2~),
 Description: client for setting system time from NTP servers
  NTP, the Network Time Protocol, is used to keep computer clocks
  accurate by synchronizing them over the Internet or a local network,
@@ -99,6 +96,30 @@
  If the full NTP daemon from the package "ntpsec" is installed, then
  ntpsec-ntpdate is not necessary.
 
+Package: ntpsec-ntpdig
+Architecture: any
+Depends: python3 (>= 3.3),
+         python3-ntp (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends},
+Breaks: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
+        sntp (<< 1:4.2.8p15+dfsg-2~),
+Replaces: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
+          sntp (<< 1:4.2.8p15+dfsg-2~),
+Description: ntpdig SNTP client
+ NTP, the Network Time Protocol, is used to keep computer clocks
+ accurate by synchronizing them over the Internet or a local network,
+ or by following an accurate hardware receiver that interprets GPS,
+ DCF-77, or similar time signals.
+ .
+ ntpdig can be used as an SNTP client to query a NTP or SNTP server
+ and either display the time or set the local system's time.  It is not
+ sufficient, however, for maintaining an accurate clock in the long run.
+ .
+ This is the NTPsec version of ntpdig, which is equivalent to the sntp
+ utility.  NTPsec is a secure, hardened, and improved implementation
+ derived from the original NTP project.
+
 Package: ntpsec-ntpviz
 Architecture: any
 Depends: adduser,
@@ -128,6 +149,8 @@
 Package: ntpsec-doc
 Architecture: all
 Depends: ${misc:Depends},
+Breaks: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
+Replaces: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
 Section: doc
 Multi-Arch: foreign
 Description: Network Time Protocol documentation
@@ -161,3 +184,40 @@
  .
  This is part of NTPsec.  NTPsec is a secure, hardened, and improved
  implementation derived from the original NTP project.
+
+Package: ntp
+Architecture: all
+Section: oldlibs
+Depends: ntpsec,
+         ${misc:Depends},
+Description: Network Time Protocol daemon/utilities (transitional package)
+ This is a dummy transitional package to transition to NTPsec.
+ It can be safely removed.
+
+Package: ntp-doc
+Architecture: all
+Section: oldlibs
+Depends: ntpsec-doc,
+         ${misc:Depends},
+Description: Network Time Protocol docs (transitional package)
+ This is a dummy transitional package to transition to NTPsec.
+ It can be safely removed.
+
+Package: ntpdate
+Architecture: all
+Section: oldlibs
+Depends: ntpsec-ntpdate,
+         ${misc:Depends},
+Description: Network Time Protocol client (transitional package)
+ This is a dummy transitional package to transition to NTPsec.
+ It can be safely removed.
+
+Package: sntp
+Architecture: all
+Section: oldlibs
+Depends: ntpsec-ntpdig,
+         ${misc:Depends},
+Description: Network Time Protocol client (transitional package)
+ This is a transitional package to transition to NTPsec.
+ It can be safely removed once all uses of sntp(1) have been converted to
+ run ntpdig instead.
